pipeline {
    agent any

    // API_URI - адрес Strapi
    // GRAPHQL_URI - используется в src/apollo/index.js для связи с GraphQL на бекенде.
    // ANSIBLE_HOST_KEY_CHECKING - не проводить проверку ключа хоста, на котором будет работать Ansible.
    environment {
        API_URI = 'https://roboto.pro:1338'
        GRAPHQL_URI = 'https://roboto.pro:1338/graphql'
        ANSIBLE_HOST_KEY_CHECKING = 'False'
    }

    stages {
        stage('Clean'){
            steps {
                cleanWs()
            }
        }

        stage('Source') {
            steps {
                git branch: 'main', url: 'https://gitlab.com/teknokomo/roboto-pro-front-strapi-quasar.git'
            }
        }

        stage('Build') {
            steps {
                nodejs(nodeJSInstallationName: 'NodeJS14') {
                    sh '''
                      yarn install
                      npx quasar build
                    '''
                }
            }
        }

        stage('Deploy') {
            steps {
                sh '''
                    tar -cvzf roboto.pro.tar.gz -C dist/spa/ .
                '''
                // На сервере Jenkins мало ресурсов. Артефакты пока не храним.
//                 archiveArtifacts artifacts: 'roboto.pro.tar.gz', fingerprint: true

                // Если сценарий запускается локально, то ему не нужна отдельная УЗ пользователя,
                // так как сценарий будет выполняться от имени jenkins
                ansiblePlaybook(
//                     credentialsId: 'Samodelkin',
                    inventory: 'pipeline/ansible/hosts.ini',
                    playbook: 'pipeline/ansible/playbook.yml',
//                     disableHostKeyChecking: true,
                    colorized: true
                )
            }
        }
    }
}
